#ifdef GL_ES
	precision mediump float;
#endif

uniform sampler2D u_texture;
uniform float desaturation;

varying vec4 v_color;
varying vec2 v_texCoords;

void main()
{
	vec4 c = texture2D(u_texture, v_texCoords) * v_color;
	float intensity = (0.3 * c.r) + (0.59 * c.g) + (0.11 * c.b);
	gl_FragColor.r = c.r * (1.0 - desaturation) + intensity * desaturation;
	gl_FragColor.g = c.g * (1.0 - desaturation) + intensity * desaturation;
	gl_FragColor.b = c.b * (1.0 - desaturation) + intensity * desaturation;
	gl_FragColor.a = c.a;
}