#ifdef GL_ES
precision mediump float; 
#endif
varying vec2 v_texCoords;
uniform sampler2D s_texture;
uniform vec4 u_ambientColor;
uniform float desaturation;
vec4 c;

void main()
{
	vec4 outColor = texture2D( s_texture, v_texCoords.xy * 8.0);
	c.r = (outColor.r + u_ambientColor.r) * u_ambientColor.a;
	c.g = (outColor.g + u_ambientColor.g) * u_ambientColor.a;
	c.b = (outColor.b + u_ambientColor.b) * u_ambientColor.a;
	c.a = outColor.a * 0.35;

	float intensity = (0.3 * c.r) + (0.59 * c.g) + (0.11 * c.b);
	gl_FragColor.r = c.r * (1.0 - desaturation) + intensity * desaturation;
	gl_FragColor.g = c.g * (1.0 - desaturation) + intensity * desaturation;
	gl_FragColor.b = c.b * (1.0 - desaturation) + intensity * desaturation;
	gl_FragColor.a = c.a;
  
}